.MEMORYMAP
DEFAULTSLOT 0
SLOTSIZE 148
SLOT 0 START $959C SIZE 148
.ENDME

.ROMBANKSIZE 148
.ROMBANKS 1


; ---------------------- code ------------------
.SLOT 0 
.BANK 0

.ORGA $959C

.EQU reentry_addr_before_copy	$916e
.EQU reentry_addr_after_copy	$9179

; Jumped to from $916b.
; Original content at $916b:
; $4A 	lsr A
; $4A 	lsr A
; $AA	txa
;
; Replaced by 4C 9C 95	(jmp 959c)
;
fixup:
	lsr A		; perform the operations we have overwritten
	lsr A		; with a JMP to this code. It will also place
	tax		; the copy length in X for our loop.

	; push A, Y and Flags
	pha		
	tya		
	pha		
	php		

	; look if the destination address
	; is in the $3fxx range
	ldy #$00	; get first byte of
	lda ($00),Y	; transfer struct,
	cmp #$3f	; check if it's $3f
		
	beq palette_copy; if so, jump to our special transfer code

	; else...

	; pop Flags, Y and A
	plp		
	pla		
	tay		
	pla		
	
	jmp reentry_addr_before_copy	; and continue to normal copy loop

palette_copy:
	; pop flags, Y and A
	plp	; Important for the BCS instruction that's coming
	pla	
	tay
	pla
	
fixup_loop:
	bcs	no_preinc
	iny	
no_preinc:
	; push X, we use it as index during the loop
	txa	
	pha	

	lda ($00),Y	; read one of the bytes to be transferred
	and #$3f	; it's palette data so force it to valid range (0-63)

	; lookup the corrected value, store it in A
	tax			
	lda.w palette_lut,X	
	and #$3f	; force valid range again (IMPORTANT)

	sta $2007	; write the corrected value

	; pop X, now it's our loop counter
	pla	
	tax	

	; are we done yet?
	dex
	bne fixup_loop

	; go back, but after the normal copy loop
	jmp reentry_addr_after_copy

; From advancemame-0.101.0/src/machine/vsnes
; RP2C05-004
palette_lut:
.DB	$18, $ff, $1c, $89, $ff, $ff, $01, $17 	; $00 - $07
.DB	$10, $0f, $2a, $ff, $36, $37, $1a, $ff 	; $08 - $0f
.DB	$25, $ff, $12, $ff, $0f, $ff, $ff, $26 	; $10 - $17
.DB	$ff, $ff, $22, $ff, $ff, $0f, $3a, $21 	; $18 - $1f
.DB	$05, $0a, $07, $c2, $13, $ff, $00, $15 	; $20 - $27
.DB	$0c, $ff, $11, $ff, $ff, $38, $ff, $ff 	; $28 - $2f 
.DB	$ff, $ff, $08, $45, $ff, $ff, $30, $3c 	; $30 - $37 
.DB	$0f, $27, $ff, $60, $29, $ff, $30, $09  ; $38 - $3f 



